/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Intermedia del 21/04/2009
 * 
 * Esercizio 1
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */

public class Corso
{
    // varibaili di istanza
    private final int codice;
    private final String nome;
    private String obiettivi;
    private String programma;

    /**
     * Costruttore della classe
     * Prevede l'inizializzazione dei soli campi obbligatori
     * 
     * @param codice    codice del corso
     * @param nome      nome del corso
     */
    public Corso(int codice, String nome)
    {
        this.codice = codice;
        this.nome = nome;
    }

    /**
     * getter per il codice del corso
     * 
     * @return          il codice del corso
     */
    public int getCodice()
    {
        return codice;
    }

    /**
     * getter per il nome del corso
     * 
     * @return          il nome del corso
     */
    public String getNome()
    {
        return nome;
    }

    /**
     * getter per gli obiettivi del corso
     * 
     * @return          gli obiettivi del corso
     */
    public String getObiettivi()
    {
        return obiettivi;
    }

    /**
     * getter per il programma del corso
     * 
     * @return          il programma del corso
     */
    public String getProgramma()
    {
        return programma;
    }

    /**
     * setter per gli obiettivi del corso
     * 
     * @param programma     gli obiettivi del corso
     */
    public void setObiettivi(String obiettivi)
    {
        this.obiettivi = obiettivi;
    }

    /**
     * setter per il programma del corso
     * 
     * @param programma     il programma del corso
     */
    public void setProgramma(String programma)
    {
        this.programma = programma;
    }
    
    /**
     * Sovrascrittura del metodo toString
     * 
     * @return      una stringa con i dati del corso 
     */
    public String toString()
    {
        return "Corso \"" + getNome() + "\", codice: " + getCodice() 
            + ((getObiettivi() == null) ? "\nObiettivi:\n" + getObiettivi() : "")
            + ((getProgramma() == null) ? "\nProgramma:\n" + getProgramma() : "")
            + "\n";
    }
}
