/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Intermedia del 21/04/2009
 * 
 * Esercizio 2
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */

public class Docente extends Persona
{
    // variabili di istanza
    private final int codice;
    private int corsi[];

    /**
     * Costruttore della classe
     * Prevede l'inizializzazione dei soli campi obbligatori
     * 
     * @param codice    codice del docente
     * @param nome      nome del docente
     * @param cognome   cognome del docente
     */
    public Docente(int codice, String nome, String cognome)
    {
        super(nome, cognome); // richiama il costruttore della superclasse
        this.codice = codice;
    }
    
    /**
     * Costruttore della classe
     * Prevede anche l'inizializzazione del campo non
     * obbligatorio email ereditato da Persona
     * (Questo costruttore non e' strettamente necessario)
     * 
     * @param codice    codice del docente
     * @param nome      nome del docente
     * @param cognome   cognome del docente
     * @param email     email del docente
     */
    public Docente(int codice, String nome, String cognome, String email)
    {
        this(codice, nome, cognome);
        setEmail(email);
    }

    /**
     * getter per il codice del docente
     * 
     * @return          il codice del docente
     */
    public int getCodice()
    {
        return codice;
    }
    
    /**
     * getter per l'array dei corsi del docente
     * 
     * @return          i corsi del docente
     */
    public int[] getCorsi()
    {
        return corsi;
    }
    
    /**
     * setter per l'array dei corsi del docente
     * 
     * @param corsi     array con i corsi del docente
     */
    public void setCorsi(int[] corsi)
    {
        this.corsi = corsi;
    }

    /**
     * verifica se un docente insegna un dato corso
     * 
     * @param codCorso  codice del corso
     * @return          true se codCorso e' nell'array dei corsi
     *                  del docente, false altrimenti
     */
    public boolean insegnaCorso(int codCorso)
    {
        if (corsi == null)
            return false;
        for (int i = 0; i < corsi.length; i++)
            if (corsi[i] == codCorso)
                return true;
        return false;
    }
    
    /**
     * Sovrascrittura del metodo toString (non stampa i corsi insegnati)
     * 
     * @return      una stringa con i dati del docente
     */
    public String toString()
    {
        return "Docente\nCodice: " + getCodice()
            + super.toString();
    }
}
