/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Intermedia del 21/04/2009
 * 
 * Esercizio 3

 * Contiene solo il codice della funzione dell'esercizio 3
 * Non ha variabili di istanza e non ha costruttori
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */

import java.util.ArrayList;

public final class Esercizio3
{
    private Esercizio3() {} // nascondo il costruttore di default
    
    /**
     * Costruisce la lista delle email degli studenti contenuti in una
     * lista di persone che frequentano un dato corso
     * 
     * @param listaPersone  lista di persone
     * @param codcorso      codice corso
     * @return              la lsita delle email
     */
    static public ArrayList<String> emailStudenti(ArrayList<Persona> listaPersone,
                                            int codCorso)
    {
        ArrayList<String> listaEmail = new ArrayList<String>();
        for (Persona pers : listaPersone)
            if (pers instanceof Studente && 
                    ((Studente)pers).freqCorso(codCorso))
            {
                // se lo studente ha un email la aggiunge alla lista
                if (pers.getEmail() != null)
                    listaEmail.add(pers.getEmail());
            }
        return listaEmail;
    }
}
