/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Intermedia del 21/04/2009
 * 
 * Esercizio 5
 * 
 * Contiene solo le due classi dell'esercizio
 * intene e statiche
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */

public class Esercizio5
{
    private Esercizio5() {} // nascondo il costruttore di default

    public static class Punto2 {
        private int x;
        private int y;
        /* 
         * Unico costruttore della classe.
         * Il costruttore di default (senza argomenti)
         * non e' piu' accessibile.
         */
        public Punto2(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }

    public static class Punto3 extends Punto2 {
        private int z;
        /*
         * Costruttore errato perche' contiene una
         * chiamata implicita al costruttore senza argomenti
         * della superclasse
         * public Punto3(int z) {
         *     this.z = z;
         * }
         * Una possibile versione corretta che 
         * introduce una chiamata con valori 0 e 0 
         * del costruttore della supreclasse.
         */
        public Punto3(int z) {
            super(0,0);
            this.z = z;
        }
        /*
         * Costruttore errato perche' la chiamata al costruttore
         * della superclasse non e' il primo comando
         * public Punto3(int z) {
         *     this.z = z;
         *     super(x,y);
         * }
         * Una possibile versione corretta che scambia
         * l'esecuzione dei due comandi
         */
        public Punto3(int x, int y, int z) {
            super(x, y);
            this.z = z;
        }
    }
}
