/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Intermedia del 21/04/2009
 * 
 * Esercizio 2
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */

public class Persona
{
    // variabili di istanza
    private final String nome;
    private final String cognome;
    private String email;

    /**
     * Costruttore della classe
     * Prevede l'inizializzazione dei soli campi obbligatori
     * 
     * @param nome      nome della persona
     * @param cognome   cognome della persona
     */
    public Persona(String nome, String cognome)
    {
        this.nome = nome;
        this.cognome = cognome;
    }
    
    /**
     * Costruttore della classe
     * Prevede anche l'inizializzazione del campo non
     * obbligatorio email
     * (Questo costruttore non e' strettamente necessario)
     * 
     * @param nome      nome della persona
     * @param cognome   cognome della persona
     * @param email     email della persona
     */
    public Persona(String nome, String cognome, String email)
    {
        this(nome, cognome);
        setEmail(email);
    }
    
    /**
     * getter per il nome della persona
     * 
     * @return          il nome della persona
     */
    public String getNome()
    {
        return nome;
    }
    
    /**
     * getter per il cognome della persona
     * 
     * @return          il cognome della persona
     */
    public String getCognome()
    {
        return cognome;
    }
    
    /**
     * getter per l'email della persona
     * 
     * @return          l'email della persona
     */
    public String getEmail()
    {
        return email;
    }

    /**
     * setter per l'email della persona
     * Il valore di email e' l'unico che puo' non essere inserito
     * dal costruttore dell'istanza e che e' modificabile.
     * 
     * @param email     l'email della persona
     */
    public void setEmail(String email)
    {
        this.email = email;
    }
    
    /**
     * Sovrascrittura del metodo toString
     * 
     * @return      una stringa con i dati della persona 
     */
    public String toString()
    {
        return "Cognome: " + getCognome()
            + "\nNome: " + getNome()
            + ((getEmail() != null) ? "\nEmail: " + getEmail() : "")
            + "\n";
    }
}
